<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SeatEquipment ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SeatEquipment extends AbstractStructArrayBase
{
    /**
     * The SeatEquipment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SeatEquipment[]
     */
    public $SeatEquipment;
    /**
     * Constructor method for ArrayOfJP_SeatEquipment
     * @uses ArrayOfJP_SeatEquipment::setSeatEquipment()
     * @param \StructType\JP_SeatEquipment[] $seatEquipment
     */
    public function __construct(array $seatEquipment = array())
    {
        $this
            ->setSeatEquipment($seatEquipment);
    }
    /**
     * Get SeatEquipment value
     * @return \StructType\JP_SeatEquipment[]|null
     */
    public function getSeatEquipment()
    {
        return $this->SeatEquipment;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatEquipment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatEquipment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatEquipmentForArrayConstraintsFromSetSeatEquipment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_SeatEquipmentSeatEquipmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SeatEquipmentSeatEquipmentItem instanceof \StructType\JP_SeatEquipment) {
                $invalidValues[] = is_object($arrayOfJP_SeatEquipmentSeatEquipmentItem) ? get_class($arrayOfJP_SeatEquipmentSeatEquipmentItem) : sprintf('%s(%s)', gettype($arrayOfJP_SeatEquipmentSeatEquipmentItem), var_export($arrayOfJP_SeatEquipmentSeatEquipmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatEquipment property can only contain items of type \StructType\JP_SeatEquipment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatEquipment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SeatEquipment[] $seatEquipment
     * @return \ArrayType\ArrayOfJP_SeatEquipment
     */
    public function setSeatEquipment(array $seatEquipment = array())
    {
        // validation for constraint: array
        if ('' !== ($seatEquipmentArrayErrorMessage = self::validateSeatEquipmentForArrayConstraintsFromSetSeatEquipment($seatEquipment))) {
            throw new \InvalidArgumentException($seatEquipmentArrayErrorMessage, __LINE__);
        }
        $this->SeatEquipment = $seatEquipment;
        return $this;
    }
    /**
     * Add item to SeatEquipment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SeatEquipment $item
     * @return \ArrayType\ArrayOfJP_SeatEquipment
     */
    public function addToSeatEquipment(\StructType\JP_SeatEquipment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SeatEquipment) {
            throw new \InvalidArgumentException(sprintf('The SeatEquipment property can only contain items of type \StructType\JP_SeatEquipment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatEquipment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SeatEquipment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SeatEquipment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SeatEquipment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SeatEquipment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SeatEquipment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatEquipment
     */
    public function getAttributeName()
    {
        return 'SeatEquipment';
    }
}
